﻿using RimWorld;
using System.Collections.Generic;
using System.Linq;
using Verse;
using RimWorld.Planet;

namespace YayoPollution
{


    public static class dataUtility
    {
        
        public static readonly Dictionary<WorldObject, yyPollutionData> dic_yyPollution = new Dictionary<WorldObject, yyPollutionData>();
        public static readonly Dictionary<World, worldData> dic_world = new Dictionary<World, worldData>();



        public static yyPollutionData GetData(WorldObject wo)
        {
            if (!dic_yyPollution.ContainsKey(wo)) {
                dic_yyPollution[wo] = new yyPollutionData();
            }
            dic_yyPollution[wo].setParent(wo);
            return dic_yyPollution[wo];
        }
        
        public static void Remove(WorldObject wo)
        {
            dic_yyPollution.Remove(wo);
        }



        public static worldData GetData(World key)
        {
            if (!dic_world.ContainsKey(key)) dic_world[key] = new worldData();
            dic_world[key].setParent(key);
            return dic_world[key];
        }

        public static void Remove(World key)
        {
            dic_world.Remove(key);
        }






    }


}
